;***********************************************************
;tim0_ovf
;***********************************************************
; Wichtigster Timer.
; Hier werden folgende Dinge getan:
;	- Status LED blinkt
;	- Kontrolle ob "startflag" gesetzt, wenn ja, Rotor drehen
;	- Tastenentprellung
;	- Wenn Taste gedrueckt, dann Eingabe Auswerten
;***********************************************************

tim0_ovf:
	in savesreg,SREG

	clr key_press
	clr key_press2

	inc zaehler		; Dieser Teil ist fuer die Status LED
	cpi zaehler, 50
	brlo ledan
	brsh ledaus
ledaus:
	ldi temp,0b00100000
	out PORTC,temp
	rjmp letsgo
ledan:
	ldi temp, 0b00000000
	out PORTC,temp

letsgo:

	sbic pind, taste_stern	; Wenn '*' Taste gedrckt, dann reset
	rjmp letsgo2
	ldi flags, 1<<bremsflag
	ldi temp, 1<<TOIE0^1<<OCIE1
	out TIMSK, temp
	
letsgo2:
	

	sbrc flags,startflag	; Wenn "startflag" gesetzt ist, Rotor drehen und Interrupt beenden!
	rjmp turn
	
				; Beginn von Peter Dannegger's Code zur Tastenentprellung
				; <http://www.mikrocontroller.net/forum/read-4-20549.html>
		in	iwr0, PIND
		com 	iwr0
		eor	iwr0, key_state
		and	key_ct0, iwr0		;reset counter
		and	key_ct1, iwr0
		com	key_ct0			;count
		eor	key_ct1, key_ct0
		and	iwr0, key_ct0		;input AND last counterstate
		and	iwr0, key_ct1
		eor	key_state, iwr0		;toggle state
		and	iwr0, key_state		;0-1-transition
		or	key_press, iwr0		;store key press detect

		in	iwr1, PINB
		com 	iwr1
		eor	iwr1, key_state2
		and	key_ct2, iwr1		;reset counter
		and	key_ct3, iwr0
		com	key_ct2			;count
		eor	key_ct3, key_ct2
		and	iwr1, key_ct2		;input AND last counterstate
		and	iwr1, key_ct3
		eor	key_state2, iwr1	;toggle state
		and	iwr1, key_state2	;0-1-transition
		or	key_press2, iwr1	;store key press detect
				; Ende des Codes zur Tastenentprellung
	
	mov temp, key_press
	ldi temp2, 0b11111011
	and key_press, temp2
	breq weiter
	rcall pindauswertung
weiter:
	mov temp, key_press2
	cpi temp, 0
	breq end_tim0_ovf
	rcall pinbauswertung
end_tim0_ovf:
	out SREG, savesreg
reti
