;***********************************************************
;multi
;***********************************************************
; Erwartet: Faktoren in temp und temp2
; Gibt zurueck:	Ergebniss in temp3
;***********************************************************

multi:
	add temp3,temp
	dec temp2
	brne multi
ret



;***********************************************************
;process_numbers
;***********************************************************
; Sortiert die ankommenden Ziffern in die Zahlenregister zahl1..zahl3 ein
; Bei Verarbeitung der 3. Ziffer wird Timer1 gestartet

; Erwartet: Zahl in temp
;	    Aktuelle Ziffer in regcounter
; Gibt zurueck:
;	    Zahl im entsprechenden Register zahl1..zahl3
;***********************************************************

process_numbers:

	cpi regcounter, 2		; "regcounter" mit 2 vergleichen
	brlo ziffer1add			; in Register "zahl1" einsortieren wenn kleiner
	breq ziffer2add			; in Register "zahl2" einsortieren wenn gleich
	mov ziffer3, temp		; in Register "zahl3" einsortieren wenn groesser
	clr regcounter			; "regcounter" zuruecksetzen
	ldi temp, 1<<TOIE0^1<<OCIE1	; Timer1 aktivieren
	out TIMSK, temp
	rjmp process_end_1
ziffer1add:
	mov ziffer1, temp
	rjmp process_end
ziffer2add:
	mov ziffer2, temp
process_end:
	inc regcounter
process_end_1:
ret

;***********************************************************
;get8bit_adc
;***********************************************************
; Liesst den AD-Wandler ein und rechnet die zurueckgegebenen
; 10bit auf 8bit herunter.
; Ergebniss steht in "temp" Register
;***********************************************************

get8bit_adc:

	sbi ADCSR, ADSC			; AD-Wandler starten
	in temp, ADCL
	in temp2, ADCH
	lsr temp2
	ror temp
	lsr temp2
	ror temp			; 8-Bit Ergebniss steht in "temp"
ret